unit MainForm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Dialogs, StdCtrls, Buttons, StrUtils, Math, process, Controls;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    LEXTRA: TLabel;
    prcExt: TProcess;
    odRestoreMBR: TOpenDialog;
    saveMBR: TCheckBox;
    sdSavePrevMBR: TSaveDialog;
    odOpenImage: TOpenDialog;
    sdSaveEmbMbr: TSaveDialog;
    TEST: TBitBtn;
    INSTALL: TBitBtn;
    QUIT: TBitBtn;
    BROWSE_SAVE: TBitBtn;
    RESTORE_SAVE: TCheckBox;
    RESTORE_PREVMBR: TCheckBox;
    SAVEFILE: TEdit;
    GROUPBOX3: TGroupBox;
    LSAVEFILE: TLabel;
    LOADSEG: TEdit;
    BOOTFILE: TEdit;
    EXTRA: TEdit;
    HOTKEY: TEdit;
    LLOADSEG: TLabel;
    LBOOTFILE: TLabel;
    LHOTKEY: TLabel;
    TIMEOUT: TEdit;
    LTIMEOUT: TLabel;
    VERBOSE: TCheckBox;
    DISABLE_FLOPPY: TCheckBox;
    PREVMBR_FIRST: TCheckBox;
    IS_FLOPPY: TCheckBox;
    SILENT: TCheckBox;
    NO_BACKUP_MBR: TCheckBox;
    DISABLE_OSBR: TCheckBox;
    GRUB2: TCheckBox;
    SKIP: TCheckBox;
    GROUPBOX2: TGroupBox;
    OUTPUT: TCheckBox;
    PARTS: TComboBox;
    FILESYSTEM: TComboBox;
    FILENAME: TEdit;
    ISFILE: TRadioButton;
    LFILESYSTEM: TLabel;
    LPART: TLabel;
    REFRESH_DISK: TBitBtn;
    DISKS: TComboBox;
    GROUPBOX1: TGroupBox;
    ISDISK: TRadioButton;
    BROWSE: TBitBtn;
    REFRESH_PART: TBitBtn;
    procedure BROWSEClick(Sender: TObject);
    procedure BROWSE_SAVEClick(Sender: TObject);
    procedure DISKSChange(Sender: TObject);
    procedure DISKSSelect(Sender: TObject);
    procedure FILENAMEChange(Sender: TObject);
    procedure FILESYSTEMChange(Sender: TObject);
    procedure INSTALLClick(Sender: TObject);
    procedure ISDISKClick(Sender: TObject);
    procedure ISFILEClick(Sender: TObject);
    procedure OUTPUTClick(Sender: TObject);
    procedure QUITClick(Sender: TObject);
    procedure REFRESH_DISKClick(Sender: TObject);
    procedure REFRESH_PARTClick(Sender: TObject);
    procedure RESTORE_PREVMBRClick(Sender: TObject);
    procedure saveMBRClick(Sender: TObject);
    procedure RESTORE_SAVEClick(Sender: TObject);
    procedure TESTClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  frmMain: TfrmMain;
  version: String = '1.4';

implementation

{$R *.lfm}

uses output;

{ TfrmMain }




procedure TfrmMain.REFRESH_DISKClick(Sender: TObject);
var
   t: TextFile;
   strTemp, drvSize: String;
   i, j, l, p1, p2: Integer;
   sz: Double;
   csz, mu: AnsiString;
   OutputLines: TStringList;
   VProcess: TProcess;
   drvLetter: AnsiChar;

  procedure Round3;
  var
     k, n: Integer;
  begin
     k := 0;
     if sz < 100 then
     begin
        while sz < 1000 do
        begin
           sz := sz * 10;
           Inc(k);
        end;
        Dec(k);
        csz := IntToStr(Floor(sz / 10));
        if k <= 2 then
           Insert('.', csz, 4 - k)
        else
        begin
           for n := 1 to k - 2 do
              csz := '0' + csz;
           Insert('.', csz, 2);
        end;
     end
     else if sz > 1000 then
     begin
        while sz > 100 do
        begin
           sz := sz / 10;
           Inc(k);
        end;
        Dec(k);
        csz := IntToStr(Floor(sz * 10));
        for n := 1 to k do
           csz := csz + '0';
     end
     else
        csz := IntToStr(Floor(sz));
  end;

begin
   Disks.Items.BeginUpdate;
   Disks.Items.Clear;
   Parts.Items.Clear;
   is_floppy.Checked := False;

   if not FileExists('/proc/partitions') then
   begin
      Disks.Items.EndUpdate;
      if Sender <> nil then
         MessageDlg('Could not find "/proc/partitions"!', mtError, [mbOK], 0);
      Exit;
   end;
   OutputLines := TStringList.Create;
   VProcess := TProcess.Create(nil);
   try
      VProcess.Executable := '/bin/sh';
      VProcess.Parameters.Append('-c');
      VProcess.Parameters.Append('ls -l /dev/disk/by-id');
      VProcess.Options := VProcess.Options + [poWaitOnExit, poUsePipes];
      VProcess.PipeBufferSize := 4096;
      VProcess.Execute;
      OutputLines.LoadFromStream(VProcess.Output);
   except
      MessageDlg('Error running ls command!', mtError, [mbOK], 0);
   end;
   VProcess.Free;
   {$i-}
   AssignFile(t, '/proc/partitions');
   FileMode := 0;
   Reset(t);
   {$i+}
   if IOResult > 0 then
   begin
      Disks.Items.EndUpdate;
      if Sender <> nil then
         MessageDlg('Could not read from "/proc/partitions"!', mtError, [mbOK], 0);
      Exit;
   end;
   while not Eof(t) do
   begin
      {$i-}
      Readln(t, strTemp);
      {$i+}
      if IOResult > 0 then
      begin
         CloseFile(t);
         Disks.Items.EndUpdate;
         if Sender <> nil then
            MessageDlg('Could not read from "/proc/partitions"!', mtError, [mbOK], 0);
         Exit;
      end;
      if Pos('ds ', ReverseString(strTemp)) <> 2 then
         Continue;
      l := Length(strTemp);
      if strTemp[l] in ['a'..'z'] then
      begin
         drvSize := '';
         i := l - 4;
         while (i > 0) and (strTemp[i] in ['0'..'9']) do
         begin
            drvSize := strTemp[i] + drvSize;
            Dec(i);
         end;
         sz := StrToInt64def(drvSize, 0) / 1048576;
         if sz < 1 then
         begin
            sz := sz * 1024;
            mu := ' MB';
         end
         else if sz >= 1024 then
         begin
            sz := sz / 1024;
            mu := ' TB';
         end
         else
            mu := ' GB';
         Round3;
         drvLetter := strTemp[l];
         strTemp := '';
         for j := 0 to OutputLines.Count do
            if Pos(drvLetter + 'ds/../.. >- ', ReverseString(OutputLines[j])) = 1 then
            begin
               strTemp := ReverseString(OutputLines[j]);
               p1 := Pos('_', strTemp);
               if p1 = 0 then
                  Continue;
               Inc(p1);
               p2 := PosEx(' ', strTemp, p1);
               if p2 = 0 then
                  Continue;
               strTemp := ReverseString(ReplaceStr(Copy(strTemp, p1, p2 - p1), '_', ' '));
               p1 := Pos('-', strTemp);
               if (p1 < 2) or (p1 > 6) then
                  Continue;
               strTemp := UpperCase(Copy(strTemp, 1, p1 - 1)) + '  ' + Copy(strTemp, p1 + 1, Length(strTemp) - p1);
               Break;
            end;
         if strTemp <> '' then
            Disks.Items.Append('hd' + IntToStr(Byte(drvLetter) - Byte('a')) + ': ' + strTemp + ', [' + csz + mu + ']')
         else
            Disks.Items.Append('hd' + IntToStr(Byte(drvLetter) - Byte('a')) + ': Unknown, [' + csz + mu + ']')
      end;
   end;
   Disks.Items.EndUpdate;
   OutputLines.Free;
end;

procedure TfrmMain.DISKSChange(Sender: TObject);
begin
   isdisk.Checked := True;
   REFRESH_PARTClick(nil);
end;

procedure TfrmMain.DISKSSelect(Sender: TObject);
begin
   Isdisk.Checked := True;
end;

procedure TfrmMain.FILENAMEChange(Sender: TObject);
begin
   isfile.Checked := True;
end;

procedure TfrmMain.BROWSEClick(Sender: TObject);
var
   strTemp: String;
begin
     if ExtractFileName(odOpenImage.FileName) <> '' then
     begin
        strTemp := odOpenImage.FileName;
        odOpenImage.FileName := '';
        odOpenImage.InitialDir := ExtractFileDir(strTemp);
     end;
     if odOpenImage.Execute then
     begin
        Filename.Text := odOpenImage.FileName;
        isfile.Checked := True;
        REFRESH_PARTClick(nil);
     end;
end;

procedure TfrmMain.BROWSE_SAVEClick(Sender: TObject);
var
   strTemp: String;
begin
  if output.Checked then
  begin
     if ExtractFileDir(sdSaveEmbMbr.FileName) <> '' then
     begin
        strTemp := sdSaveEmbMbr.FileName;
        sdSaveEmbMbr.FileName := ExtractFileName(strTemp);
        sdSaveEmbMbr.InitialDir := ExtractFileDir(strTemp);
     end
     else
     begin
        sdSaveEmbMBR.FileName := 'grldr.mbr';
        sdSaveEmbMBR.FilterIndex := 0;
     end;
     if sdSaveEmbMbr.Execute then
        savefile.Text := sdSaveEmbMbr.FileName;
  end
  else
  if restore_save.Checked then
  begin
     if ExtractFileName(odRestoreMbr.FileName) <> '' then
     begin
        strTemp := odRestoreMbr.FileName;
        odRestoreMbr.FileName := '';
        odRestoreMbr.InitialDir := ExtractFileDir(strTemp);
     end
     else
        odRestoreMbr.FileName := 'MBR.bin';
     if odRestoreMbr.Execute then
        savefile.Text := odRestoreMbr.FileName;
  end
  else
  begin
     if ExtractFileDir(sdSavePrevMbr.FileName) <> '' then
     begin
        strTemp := sdSavePrevMbr.FileName;
        sdSavePrevMbr.FileName := ExtractFileName(strTemp);
        sdSavePrevMbr.InitialDir := ExtractFileDir(strTemp);
     end
     else
        sdSavePrevMBR.FileName := 'MBR.bin';
     if sdSavePrevMbr.Execute then
     begin
        savefile.Text := sdSavePrevMbr.FileName;
        saveMBR.Checked := True;
     end;
  end;
end;

procedure TfrmMain.FILESYSTEMChange(Sender: TObject);
begin
   if DISKS.ItemIndex >= 0 then
      REFRESH_PARTClick(nil)
   else
   begin
     PARTS.Items.Clear;
     is_floppy.Checked := False;
   end;
end;

procedure TfrmMain.INSTALLClick(Sender: TObject);
const
   READ_BYTES = 2048;
var
   OutputLines: TStringList;
   MemStream: TMemoryStream;
   NumBytes: LongInt;
   i, j, BytesRead, l, qn: LongInt;
   strTemp, drvNumber: String;
   drvLetter: Char;
begin
   if ((isdisk.Checked and (disks.ItemIndex = -1)) or (isfile.Checked and (filename.Text = ''))) and (not output.Checked) then
   begin
      MessageDlg('No device selected!', mtWarning, [mbOK], 0);
      if isdisk.Checked then
         Disks.SetFocus
      else
         Filename.SetFocus;
      Exit;
   end;
   prcExt.Executable := 'grubinst';
   prcExt.CurrentDirectory := ExtractFileDir(ParamStr(0));
   if not FileExists(prcExt.CurrentDirectory + '/' + prcExt.Executable) then
   begin
      MessageDlg('grubinst not found!', mtError, [mbOK], 0);
      Exit;
   end;
   prcExt.Parameters.Clear;
   if Sender = nil then
      prcExt.Parameters.Append('--read-only');
   case Filesystem.ItemIndex of
      1:   prcExt.Parameters.Append('--file-system-type=MBR');
      2:   prcExt.Parameters.Append('--file-system-type=NTFS');
      3:   prcExt.Parameters.Append('--file-system-type=FAT32');
      4:   prcExt.Parameters.Append('--file-system-type=FAT16');
      5:   prcExt.Parameters.Append('--file-system-type=EXT2');
   end;
   if OUTPUT.Checked then
   begin
      if savefile.Text = '' then
      begin
         savefile.SetFocus;
         MessageDlg('Please input a filename!', mtError, [mbOK], 0);
         savefile.SetFocus;
         Exit;
      end;
      prcExt.Parameters.Append('--output');
   end;
   if Verbose.Checked then
      prcExt.Parameters.Append('--verbose');
   if no_backup_mbr.Checked then
      prcExt.Parameters.Append('--no-backup-mbr');
   if DISABLE_FLOPPY.Checked then
      prcExt.Parameters.Append('--mbr-disable-floppy');
   if DISABLE_OSBR.Checked then
      prcExt.Parameters.Append('--mbr-disable-osbr');
   if PREVMBR_FIRST.Checked then
      prcExt.Parameters.Append('--boot-prevmbr-first');
   if GRUB2.Checked then
      prcExt.Parameters.Append('--grub2');
   if IS_FLOPPY.Checked then
      prcExt.Parameters.Append('--floppy');
   if Skip.Checked then
      prcExt.Parameters.Append('--skip-mbr-test');
   if Silent.Checked then
      prcExt.Parameters.Append('--silent-boot');
   prcExt.Parameters.Append('--time-out=' + IntToStr(StrToIntDef(Timeout.Text, 0)));
   if Hotkey.Text <> '' then
      prcExt.Parameters.Append('--hot-key=' + HotKey.Text);
   if loadseg.Text <> '' then
      prcExt.Parameters.Append('--load-seg=' + loadseg.Text);
   if bootfile.Text <> '' then
      prcExt.Parameters.Append('--boot-file=' + bootfile.Text);
   if RESTORE_SAVE.Checked then
   begin
      if Savefile.Text = '' then
      begin
         Savefile.SetFocus;
         MessageDlg('Please input a filename!', mtError, [mbOK], 0);
         savefile.SetFocus;
         Exit;
      end;
      prcExt.Parameters.Append('--restore=' + savefile.Text);
   end
   else
   if RESTORE_PREVMBR.Checked then
      prcExt.Parameters.Append('--restore-prevmbr');
   if SaveMBR.Checked then
   begin
      if Savefile.Text = '' then
      begin
         Savefile.SetFocus;
         MessageDlg('Please input a filename!', mtError, [mbOK], 0);
         savefile.SetFocus;
         Exit;
      end;
      prcExt.Parameters.Append('--save=' + SaveFile.Text);
   end;
   if Parts.ItemIndex > 0 then
      prcExt.Parameters.Append('--install-partition=' + Parts.Items[Parts.ItemIndex][2]);
   if Extra.Text <> '' then
   begin
      i := prcExt.Parameters.Count;
      strTemp := Extra.Text;
      l := Length(strTemp);
      j := 1;
      qn := 0;
      while j <= l do
      begin
         if strTemp[j] = '"' then
         begin
            Delete(strTemp, j, 1);
            Dec(l);
            Continue;
         end
         else
            if strTemp[j] = ' ' then
               if qn mod 2 = 0 then
                  strTemp[j] := #10;
         Inc(j);
      end;
      prcExt.Parameters.Text := prcExt.Parameters.Text + strTemp;
      while i < prcExt.Parameters.Count do
      begin
         if LowerCase(prcExt.Parameters[i]) = '--pause' then
         begin
            prcExt.Parameters.Delete(i);
            Continue;
         end;
         Inc(i);
      end;
   end;
   if not output.Checked then
   begin
      if isdisk.Checked then
      begin
         strTemp := Disks.Items[Disks.ItemIndex];
         i := 3;
         l := Length(strTemp);
         drvNumber := '';
         while (i <= l) and (strTemp[i] in ['0'..'9']) do
         begin
            drvNumber := strTemp[i] + drvNumber;
            Dec(i);
         end;
         drvLetter := Char(Byte('a') + StrToInt(drvNumber));
         if (sender <> nil) and (drvletter = 'a') then
            if MessageDlg('Warning', 'This is the OS drive.'#10'Are you sure you want to install the Grub4Dos MBR/BS?',
               mtWarning,[mbYes, mbNo], 0, mbNo) <> mrYes then
                   Exit;
         prcExt.Parameters.Append('/dev/sd' + drvLetter);
      end
      else
         prcExt.Parameters.Append(Filename.Text);
   end
   else
      prcExt.Parameters.Append(savefile.Text);
   Application.CreateForm(TfrmOutput, frmOutput);
   frmOutput.mmText.Lines.BeginUpdate;
   frmOutput.mmText.Lines.Clear;
   if Sender = nil then
   begin
      strTemp := 'Starting "./grubinst';
      for i := 0 to prcExt.Parameters.Count - 1 do
         strTemp := strTemp + ' ' + prcExt.Parameters[i];
      strTemp := strTemp + '"...'#10#10;
      frmOutput.mmText.Lines.Text := strTemp;
   end;

   MemStream := TMemoryStream.Create;
   BytesRead := 0;
   OutputLines := TStringList.Create;
   try
      prcExt.Execute;
   except
      frmOutput.mmText.Lines.EndUpdate;
      OutputLines.Free;
      MemStream.Free;
      frmOutput.Free;
      MessageDlg('Error running grubinst!', mtError, [mbOK], 0);
   end;
   while True do
   begin
      MemStream.SetSize(BytesRead + READ_BYTES);
      NumBytes := prcExt.Output.Read((MemStream.Memory + BytesRead)^, READ_BYTES);
      if NumBytes > 0 then
         Inc(BytesRead, NumBytes)
      else
         Break;
   end;
   MemStream.SetSize(BytesRead);
   OutputLines.LoadFromStream(MemStream);
   frmOutput.mmText.Lines.AddStrings(OutputLines);
   frmOutput.mmText.Lines.EndUpdate;
   OutputLines.Free;
   MemStream.Free;
   if Sender = nil then
      frmOutput.Caption := 'Output Test'
   else
      frmOutput.Caption := 'Output ' + Install.Caption;
   frmOutput.ShowModal;
   frmOutput.Free;
   frmOutput := nil;
   if prcExt.Running then
      prcExt.Terminate(0);
end;

procedure TfrmMain.ISDISKClick(Sender: TObject);
begin
   if DISKS.ItemIndex >= 0 then
      REFRESH_PARTClick(nil)
   else
   begin
      PARTS.Items.Clear;
      is_floppy.Checked := False;
   end;
end;

procedure TfrmMain.ISFILEClick(Sender: TObject);
begin
   if Output.Checked then
   begin
     PARTS.Items.Clear;
     is_floppy.Checked := False;
   end
   else
   if Filename.Text <> '' then
      REFRESH_PARTClick(nil)
   else
   begin
     PARTS.Items.Clear;
     is_floppy.Checked := False;
   end;
end;

procedure TfrmMain.OUTPUTClick(Sender: TObject);
begin
   if output.Checked then
   begin
      restore_save.Checked := False;
      restore_prevmbr.Checked := False;
      saveMBR.Checked := False;
      Install.Caption := 'Save';
   end
   else
      Install.Caption := 'Install';
end;

procedure TfrmMain.QUITClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.REFRESH_PARTClick(Sender: TObject);
const
   READ_BYTES = 2048;
var
  strTemp: String;
  i, BytesRead: Integer;
  OutputLines: TStringList;
  MemStream: TMemoryStream;
  NumBytes: LongInt;
begin
   Parts.Items.BeginUpdate;
   PARTS.Items.Clear;
   is_floppy.Checked := False;
   Skip.Checked := False;
   if isFile.Checked then
   begin
      if Filename.text = '' then
      begin
         Parts.Items.EndUpdate;
         if Sender <> nil then
         begin
            MessageDlg('Please input a file name!', mtWarning, [mbOK], 0);
            Filename.SetFocus;
         end;
         Exit;
      end
      else
      if not FileExists(Filename.text) then
      begin
         Parts.Items.EndUpdate;
         if Sender <> nil then
         begin
            MessageDlg('Could not find the file!', mtWarning, [mbOK], 0);
            Filename.SetFocus;
         end;
         Exit;
      end;
   end
   else
   if DISKS.ItemIndex = -1 then
   begin
      Parts.Items.EndUpdate;
      if Sender <> nil then
      begin
         MessageDlg('Please select a disk!', mtWarning, [mbOK], 0);
         Disks.SetFocus;
      end;
      Exit;
   end;

   prcExt.Executable := 'grubinst';
   prcExt.CurrentDirectory := ExtractFileDir(ParamStr(0));
   if not FileExists(prcExt.CurrentDirectory + '/' + prcExt.Executable) then
   begin
      Parts.Items.EndUpdate;
      if Sender <> nil then
         MessageDlg('grubinst not found!', mtError, [mbOK], 0);
      Exit;
   end;

   prcExt.Parameters.Clear;
   prcExt.Parameters.Append('getpart');
   case Filesystem.ItemIndex of
      1:   prcExt.Parameters.Append('MBR');
      2:   prcExt.Parameters.Append('NTFS');
      3:   prcExt.Parameters.Append('FAT32');
      4:   prcExt.Parameters.Append('FAT16');
      5:   prcExt.Parameters.Append('EXT2');
   else
      prcExt.Parameters.Append('AutoDetect');
   end;
   if IsDisk.Checked then
   begin
      strTemp := Disks.Items[Disks.ItemIndex];
      i := Pos(' ', strTemp);
      prcExt.Parameters.Append('(' + Copy(strTemp, 1, i - 2) + ')');
   end
   else
      prcExt.Parameters.Append(Filename.Text);
   
   MemStream := TMemoryStream.Create;
   BytesRead := 0;
   OutputLines := TStringList.Create;
   try
      prcExt.Execute;
   except
      OutputLines.Free;
      MemStream.Free;
      Parts.Items.EndUpdate;
      if Sender <> nil then
         MessageDlg('Error running grubinst!', mtError, [mbOK], 0);
      Exit;
   end;
   while prcExt.Running do
   begin
      MemStream.SetSize(BytesRead + READ_BYTES);
      NumBytes := prcExt.Output.Read((MemStream.Memory + BytesRead)^, READ_BYTES);
      if NumBytes > 0 then
         Inc(BytesRead, NumBytes)
      else
         Sleep(50);
   end;
   repeat
      MemStream.SetSize(BytesRead + READ_BYTES);
      NumBytes := prcExt.Output.Read((MemStream.Memory + BytesRead)^, READ_BYTES);
      if NumBytes > 0 then
         Inc(BytesRead, NumBytes);
   until NumBytes <= 0;
   MemStream.SetSize(BytesRead);
   OutputLines.LoadFromStream(MemStream);
   if (OutputLines.Count = 0) or ((OutputLines.Count = 1) and (OutputLines[0] = 'error')) then
   begin
      OutputLines.Free;
      MemStream.Free;
      Parts.Items.EndUpdate;
      if Sender <> nil then
         MessageDlg('Error reading from device!', mtError, [mbOK], 0);
      Exit;
   end;
   i := 0;
   if OutputLines[0] = 'MBR2' then
   begin
      Skip.Checked := True;
      Inc(i);
   end;
   is_floppy.Checked := i = (OutputLines.Count - 1);
   while i < OutputLines.Count do
   begin
      Parts.Items.Append(OutputLines[i]);
      Inc(i);
   end;
   Parts.Items.EndUpdate;
   Parts.ItemIndex := 0;
   OutputLines.Free;
   MemStream.Free;
end;

procedure TfrmMain.RESTORE_PREVMBRClick(Sender: TObject);
begin
   if restore_prevmbr.Checked then
   begin
      output.Checked := False;
      restore_save.Checked := False;
      saveMBR.Checked := False;
      Install.Caption := 'Restore';
   end
   else
      Install.Caption := 'Install';
end;

procedure TfrmMain.saveMBRClick(Sender: TObject);
begin
   if saveMBR.Checked then
   begin
      output.Checked := False;
      restore_prevmbr.Checked := False;
      restore_save.Checked := False;
      install.Caption := 'Save && Install';
      install.Width := install.Width + 14;
      install.Left := install.Left - 7;
   end
   else
   begin
      if install.Caption = 'Save && Install' then
      begin
         install.Width := install.Width - 14;
         install.Left := install.Left + 7;
      end;
      install.Caption := 'Install';
   end;
end;

procedure TfrmMain.RESTORE_SAVEClick(Sender: TObject);
begin
   if restore_save.Checked then
   begin
      output.Checked := False;
      restore_prevmbr.Checked := False;
      saveMBR.Checked := False;
      Install.Caption := 'Restore';
   end
   else
      Install.Caption := 'Install';
end;

procedure TfrmMain.TESTClick(Sender: TObject);
begin
   InstallClick(nil);
end;

end.

